package mail;

use strict;
use Jcode;
use MIME::Base64::Perl;

sub check {
my $email = shift;

if($email =~ /[^a-zA-Z0-9\@\.\-\_]/) {return;}

my $atCount = 0;
while($email =~ /\@/g) {
$atCount++;
}
if($atCount != 1) {return;}

my($acnt, $domain) = split(/\@/, $email);
unless ($acnt) {return;}
unless ($domain) {return;}

my $dotCount = 0;
while($domain =~ /\./g) {
$dotCount++;
}
if($dotCount == 0) {return;}

if($domain =~ /^\./) {return;}
if($domain =~ /\.$/) {return;}
if($domain =~ /\.\./) {return;}

my @domainParts = split(/\./, $domain);
my $topLevelDomain = pop @domainParts;
if($topLevelDomain =~ /[^a-zA-Z]/) {return;}

return 1;
}

sub set {
my ($file, $input) = @_;
my %mail = ();
my @file = ();

open (FILE, $file) or return;
while (<FILE>) {
tr/\x0D\x0A//d;
while (my($key, $value) = each %{$input}) {
my $pattern = '%%' . $key . '%%';
s/$pattern/$value/;
}
push (@file, $_);
}
close(FILE);

$mail{sender} = shift @file;
$mail{subject} = shift @file;
$mail{body} = join("\n", @file);

return \%mail;
}

sub send {
my $mail = shift;

my $encodedSender = &base64encode($mail->{sender});
my $encodedSubject = &base64encode($mail->{subject});
&Jcode::convert(\$mail->{body}, 'jis', 'sjis');

open(MAIL,"| $mail->{sendmail} -t") || return;
print MAIL "From: $encodedSender\n\x20\x3C$mail->{from}\x3E\n";
print MAIL "To: $mail->{to}\n";
print MAIL "Bcc: $mail->{bcc}\n" if ($mail->{bcc} ne "");
print MAIL "Subject: $encodedSubject\n";
print MAIL "Errors-To: $mail->{error}\n";
print MAIL "MIME-version: 1.0\n";
print MAIL "X-Mailer: Mailform CGI\n";
print MAIL "Content-type: text/plain; charset=\"ISO-2022-JP\"\n";
print MAIL "Content-transfer-encoding: 7bit\n";
print MAIL "\n";
print MAIL "$mail->{body}";
print MAIL "\n";
close (MAIL);

return 1;
}

sub base64encode {
my $string = shift;

my $jcode = Jcode->new();
$jcode->set($string, 'sjis');
$string = $jcode->h2z->sjis;

my $oneByte1 = '[\x20-\x7E]';
my $oneByte2 = '[\xA1-\xDF]';
my $twoBytes1 = '[\x81-\x9F][\x40-\xFC]';
my $twoBytes2 = '[\xE0-\xEF][\x40-\xFC]';

my @char = $string =~ /$oneByte1|$oneByte2|$twoBytes1|$twoBytes2/gox;

my @jisline = ();
my $jisline = "";
foreach (@char) {
&Jcode::convert(\$_, 'jis', 'sjis');
$jisline .= $_;
if (length($jisline) > 30) {
push(@jisline, $jisline);
$jisline = "";
}
}
if (length($jisline)) {
push(@jisline, $jisline);
}

my @encoded = ();
my $encoded = "";
foreach (@jisline) {
my $base64 = MIME::Base64::Perl::encode_base64($_, "");
my $line = '=?ISO-2022-JP?B?' . $base64 . '?=';
push (@encoded, $line);
}

$encoded = join("\n\x20", @encoded);

return $encoded;
}

1;
